VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "ieframe.dll"
Begin VB.Form HBBrowser 
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   7470
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9855
   ControlBox      =   0   'False
   FillStyle       =   0  'Solid
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7470
   ScaleWidth      =   9855
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox pb 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   6855
      Left            =   240
      ScaleHeight     =   6855
      ScaleWidth      =   9135
      TabIndex        =   0
      Top             =   240
      Width           =   9135
      Begin SHDocVwCtl.WebBrowser wwweb 
         Height          =   7092
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Width           =   9492
         ExtentX         =   16743
         ExtentY         =   12509
         ViewMode        =   0
         Offline         =   0
         Silent          =   0
         RegisterAsBrowser=   1
         RegisterAsDropTarget=   1
         AutoArrange     =   0   'False
         NoClientEdge    =   0   'False
         AlignLeft       =   0   'False
         NoWebView       =   0   'False
         HideFileNames   =   0   'False
         SingleClick     =   0   'False
         SingleSelection =   0   'False
         NoFolders       =   0   'False
         Transparent     =   0   'False
         ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
         Location        =   "http:///"
      End
   End
End
Attribute VB_Name = "HBBrowser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public HBServer As HBCONTROLMODLib.HBControl
Private WithEvents Timer As ccrpTimer
Attribute Timer.VB_VarHelpID = -1
Private Cline() As String
Private szRSP As String
Private URL As String
Private Back As String
Private Forward As String
Private Reload As String
Private x As Integer
Private y As Integer
Private TimerInterval As Integer
Private ResolutionX As Integer
Private ResolutionY As Integer
Private Transparency As Integer
Private OnTop As String
Private ScrollBars As String
Private ScrollRight As String
Private ScrollLeft As String
Private ScrollUp As String
Private ScrollDown As String
Private OldURL As String
Private PageCounter As String
Private OldBack As String
Private OldForward As String
Private OldReload As String
Private OldX As Integer
Private OldY As Integer
Private OldTimerInterval As Integer
Private OldResolutionX As Integer
Private OldResolutionY As Integer
Private OldTransparency As Integer
Private OldOnTop As String
Private OldScrollBars As String
Private BrowserStop As String
Private PortNumber As Integer
Private IPAddress As String
Private Password As String
Private BrowserDevice As String
Private InstanceType As String
Private Window As Long
Private mut As clsMutex

Private Sub Form_Load()
    Cline = Split(Command, "/")
    Dim i
    For i = 0 To UBound(Cline)
        Select Case Mid(Cline(i), 1, 1)
            Case "I": IPAddress = Trim(Mid(Cline(i), 2, Len(Cline(i))))
            Case "O": PortNumber = Trim(Mid(Cline(i), 2, Len(Cline(i))))
            Case "S": Password = Trim(Mid(Cline(i), 2, Len(Cline(i))))
            Case "D": BrowserDevice = Trim(Mid(Cline(i), 2, Len(Cline(i))))
            Case "C": InstanceType = Trim(Mid(Cline(i), 2, Len(Cline(i))))
        End Select
    Next
    If Password = "*" Then Password = ""
    
    ' Look for SIB in the InstanceType string.  This will work even if there are quotes in the string.
    If InStr(InstanceType, "SIB") > 0 Then
        Set mut = New clsMutex
        ' Create a uniquely named "Mutex".  If this mutex already exists the following
        ' function call will return false and we'll exit this instance of the program.
        If Not mut.CheckMutex("HouseBotBrowser") Then 'Case sensitive string
            Unload Me
            Exit Sub
        End If
    End If
    
    Set HBServer = New HBControl
    szRSP = HBServer.Connect(PortNumber, IPAddress, Password)
    If szRSP = "OK" Then
        URL = HBServer.GetPropertyValue(BrowserDevice, "URL")
        Back = HBServer.GetPropertyValue(BrowserDevice, "Back")
        Forward = HBServer.GetPropertyValue(BrowserDevice, "Forward")
        Reload = HBServer.GetPropertyValue(BrowserDevice, "Reload")
        x = CInt(HBServer.GetPropertyValue(BrowserDevice, "X"))
        y = CInt(HBServer.GetPropertyValue(BrowserDevice, "Y"))
        TimerInterval = CInt(HBServer.GetPropertyValue(BrowserDevice, "TimerInterval"))
        If TimerInterval < 0 Then TimerInterval = 0
        ResolutionX = CInt(HBServer.GetPropertyValue(BrowserDevice, "ResolutionX"))
        ResolutionY = CInt(HBServer.GetPropertyValue(BrowserDevice, "ResolutionY"))
        Transparency = CInt(HBServer.GetPropertyValue(BrowserDevice, "Transparency"))
        If Transparency > 255 Then Transparency = 255
        If Transparency < 0 Then Transparency = 0
        OnTop = HBServer.GetPropertyValue(BrowserDevice, "OnTop")
        ScrollBars = HBServer.GetPropertyValue(BrowserDevice, "ScrollBars")
        Set Timer = New ccrpTimer
        With Timer
            .EventType = TimerPeriodic
            .Interval = TimerInterval
            .Stats.Frequency = 20
            .Enabled = True
        End With
        Call SetScrollBars
        Call SetTranslucent(Me.hwnd, Me.BackColor, Transparency, 2)
        wwweb.Navigate URL
        OldURL = URL
        OldBack = Back
        OldForward = Forward
        OldReload = Reload
        OldX = x
        OldY = y
        OldTimerInterval = TimerInterval
        OldResolutionX = ResolutionX
        OldResolutionY = ResolutionY
        OldTransparency = Transparency
        OldScrollBars = ScrollBars
        OldOnTop = OnTop
        Me.WindowState = 0
        If OnTop = "True" Then
            Window = SetTopMostWindow(Me.hwnd, True)
        Else
            Window = SetTopMostWindow(Me.hwnd, False)
        End If
        Call HBServer.SetPropertyValue(BrowserDevice, "Execute Program", "No")
    Else
        MsgBox ("Unable to connect to HouseBot. Please ensure HouseBot is open and External Control is configured.")
        Unload Me
    End If
End Sub
Private Sub SetScrollBars()
        If ScrollBars = "True" Then
            Me.wwweb.Top = -23
            Me.wwweb.Left = -23
            Me.wwweb.Height = (ResolutionY) * Screen.TwipsPerPixelX
            Me.wwweb.Width = (ResolutionX) * Screen.TwipsPerPixelY
            Me.pb.Top = 0
            Me.pb.Left = 0
            Me.pb.Height = Me.wwweb.Height
            Me.pb.Width = Me.wwweb.Width
            Me.Height = Me.wwweb.Height
            Me.Width = Me.wwweb.Width
            Me.Top = x
            Me.Left = y
        Else
            Me.wwweb.Top = -23
            Me.wwweb.Left = -23
            Me.wwweb.Height = (ResolutionY) * Screen.TwipsPerPixelX + 340
            Me.wwweb.Width = (ResolutionX) * Screen.TwipsPerPixelY + 340
            Me.pb.Top = 0
            Me.pb.Left = 0
            Me.pb.Height = Me.wwweb.Height - 340
            Me.pb.Width = Me.wwweb.Width - 340
            Me.Height = Me.wwweb.Height - 340
            Me.Width = Me.wwweb.Width - 340
            Me.Top = x
            Me.Left = y
        End If
End Sub
Sub SetTranslucent(ThehWnd As Long, color As Long, nTrans As Integer, flag As Byte)
    On Error GoTo ErrorRtn
    Dim attrib As Long
    attrib = GetWindowLong(ThehWnd, GWL_EXSTYLE)
    SetWindowLong ThehWnd, GWL_EXSTYLE, attrib Or WS_EX_LAYERED
    SetLayeredWindowAttributes ThehWnd, color, nTrans, flag
    Exit Sub
ErrorRtn:
    MsgBox Err.Description & " Source : " & Err.Source
End Sub
Private Sub Form_Unload(Cancel As Integer)
    Set HBServer = Nothing
    Set Timer = Nothing
End Sub
Private Sub Timer_Timer(ByVal Milliseconds As Long)
    On Error Resume Next
    Dim i
    If wwweb.ReadyState <> READYSTATE_COMPLETE Then
        Exit Sub
    End If
    If Me.WindowState <> 0 Then
        Me.WindowState = 0
    End If
    URL = HBServer.GetPropertyValue(BrowserDevice, "URL")
    If URL = "**Error**" Then
        Unload Me
        Exit Sub
    End If
    Back = HBServer.GetPropertyValue(BrowserDevice, "Back")
    Forward = HBServer.GetPropertyValue(BrowserDevice, "Forward")
    Reload = HBServer.GetPropertyValue(BrowserDevice, "Reload")
    x = CInt(HBServer.GetPropertyValue(BrowserDevice, "X"))
    y = CInt(HBServer.GetPropertyValue(BrowserDevice, "Y"))
    TimerInterval = CInt(HBServer.GetPropertyValue(BrowserDevice, "TimerInterval"))
    If TimerInterval < 0 Then TimerInterval = 0
    ResolutionX = CInt(HBServer.GetPropertyValue(BrowserDevice, "ResolutionX"))
    ResolutionY = CInt(HBServer.GetPropertyValue(BrowserDevice, "ResolutionY"))
    Transparency = CInt(HBServer.GetPropertyValue(BrowserDevice, "Transparency"))
    If Transparency > 255 Then Transparency = 255
    If Transparency < 0 Then Transparency = 0
    BrowserStop = HBServer.GetPropertyValue(BrowserDevice, "BrowserQuit")
    OnTop = HBServer.GetPropertyValue(BrowserDevice, "OnTop")
    ScrollBars = HBServer.GetPropertyValue(BrowserDevice, "ScrollBars")
    ScrollRight = HBServer.GetPropertyValue(BrowserDevice, "ScrollRight")
    ScrollLeft = HBServer.GetPropertyValue(BrowserDevice, "ScrollLeft")
    ScrollUp = HBServer.GetPropertyValue(BrowserDevice, "ScrollUp")
    ScrollDown = HBServer.GetPropertyValue(BrowserDevice, "ScrollDown")
    
    If OldURL <> URL Then
        wwweb.Navigate2 URL
        OldURL = URL
    End If
    If Back = "True" Then
        wwweb.GoBack
        Call HBServer.SetPropertyValue(BrowserDevice, "Back", "False")
    End If
    If Forward = "True" Then
        wwweb.GoForward
        Call HBServer.SetPropertyValue(BrowserDevice, "Forward", "False")
    End If
    If Reload = "True" Then
        wwweb.Refresh2
        Call HBServer.SetPropertyValue(BrowserDevice, "Reload", "False")
    End If
    If OldX <> x Or OldY <> y Then
        Call SetScrollBars
        OldX = x
        OldY = y
    End If
    If OldTimerInterval <> TimerInterval Then
        Timer.Interval = TimerInterval
        OldTimerInterval = TimerInterval
    End If
    If OldResolutionX <> ResolutionX Or OldResolutionY <> ResolutionY Then
        Call SetScrollBars
        OldResolutionX = ResolutionX
        OldResolutionY = ResolutionY
    End If
    If OldTransparency <> Transparency Then
        Call SetTranslucent(Me.hwnd, Me.BackColor, Transparency, 2)
        OldTransparency = Transparency
    End If
    If BrowserStop = "True" Then
        Call HBServer.SetPropertyValue(BrowserDevice, "BrowserQuit", "False")
        Unload Me
        Exit Sub
    End If
    If OnTop = "True" Then
        Window = SetTopMostWindow(Me.hwnd, True)
    Else
        Window = SetTopMostWindow(Me.hwnd, False)
    End If
    If OldScrollBars <> ScrollBars Then
        Call SetScrollBars
        OldScrollBars = ScrollBars
    End If
    If ScrollRight = "True" Then
        For i = 0 To 9
            wwweb.Document.body.doscroll ("Right")
        Next
        Call HBServer.SetPropertyValue(BrowserDevice, "ScrollRight", "False")
    End If
    If ScrollLeft = "True" Then
        For i = 0 To 9
            wwweb.Document.body.doscroll ("Left")
        Next
        Call HBServer.SetPropertyValue(BrowserDevice, "ScrollLeft", "False")
    End If
    If ScrollUp = "True" Then
        wwweb.Document.body.doscroll ("Up")
        Call HBServer.SetPropertyValue(BrowserDevice, "ScrollUp", "False")
    End If
    If ScrollDown = "True" Then
        wwweb.Document.body.doscroll ("Down")
        Call HBServer.SetPropertyValue(BrowserDevice, "ScrollDown", "False")
    End If
    Err.Clear
End Sub
Private Sub wwweb_DownloadComplete()
    On Error Resume Next
    wwweb.Document.body.Topmargin = 0
    wwweb.Document.body.Leftmargin = 0
    wwweb.Document.body.Marginwidth = 0
    wwweb.Document.body.Marginheight = 0
End Sub
